
{System/conversion/conversion_progress.i}

DEF VAR cProgram                      AS CHARACTER NO-UNDO.
DEF VAR cAction                       AS CHARACTER NO-UNDO.
DEF VAR cTable                        AS CHARACTER NO-UNDO.
DEF VAR iTotal                        AS INTEGER   NO-UNDO.
DEF VAR iDone                         AS INTEGER   NO-UNDO.
DEF VAR iLoop                         AS INTEGER   NO-UNDO.
DEF VAR iModulo                       AS INTEGER   NO-UNDO.
DEF VAR iSeqnr                        AS INTEGER   NO-UNDO.
DEF VAR lDone                         AS LOGICAL   NO-UNDO.

DISABLE TRIGGERS FOR LOAD OF dp-own-prefix.

DEFINE BUFFER b-dp-own-prefix FOR dp-own-prefix.
DEFINE BUFFER b2-dp-own-prefix FOR dp-own-prefix.

DEFINE TEMP-TABLE tt-cust_depot
         FIELD companycode LIKE dp-container.companycode
         FIELD cust_addressnr  LIKE dp-container.cust_addressnr
         FIELD depotcode LIKE dp-container.depotcode
         INDEX idx IS UNIQUE PRIMARY companycode cust_addressnr depotcode
         .




ASSIGN
  cProgram = THIS-PROCEDURE:FILE-NAME
  cAction  = "ind_inactive"
  cTable   = "dp-own-prefix"
  iTotal   = 0
  iDone    = 0
  iModulo  = 0
  .

FOR EACH sp-company NO-LOCK:

  FOR EACH dp-container WHERE
           dp-container.companycode = sp-company.companycode AND
           dp-container.recordtype = "30"
           NO-LOCK:

    FIND dp-customer WHERE
         dp-customer.companycode = dp-container.companycode AND
         dp-customer.cust_addressnr = dp-container.cust_addressnr
         NO-LOCK NO-ERROR.
    IF AVAIL dp-customer AND dp-customer.ind_sale_customer = FALSE
    THEN DO:

      FIND tt-cust_depot WHERE
           tt-cust_depot.companycode    = dp-container.companycode AND
           tt-cust_depot.cust_addressnr = dp-container.cust_addressnr AND
           tt-cust_depot.depotcode      = dp-container.depotcode
           NO-LOCK NO-ERROR.
      IF NOT AVAIL tt-cust_depot
      THEN DO:
        CREATE tt-cust_depot.
        ASSIGN tt-cust_depot.companycode    = dp-container.companycode
               tt-cust_depot.cust_addressnr = dp-container.cust_addressnr
               tt-cust_depot.depotcode      = dp-container.depotcode
               .
  iDone = iDone + 1.

  RUN DisplayProgress (cProgram, "prepare", "tt-cust_depot", iTotal, iDone).
      END.
    END.
  END.
END.


FOR EACH b-dp-own-prefix
         EXCLUSIVE-LOCK TRANSACTION :

  ASSIGN b-dp-own-prefix.containerprefix = CAPS(b-dp-own-prefix.containerprefix)
         b-dp-own-prefix.ind_inactive = FALSE
         b-dp-own-prefix.acceptcode   = "YES".

  iDone = iDone + 1
  .
  RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).
END.


do_for_each:
FOR EACH b-dp-own-prefix
         EXCLUSIVE-LOCK TRANSACTION :
  IF  b-dp-own-prefix.cust_addressnr = 0
  THEN DO:
    ASSIGN b-dp-own-prefix.ind_inactive = TRUE.
    NEXT do_for_each.
  END.
  IF b-dp-own-prefix.depotcode <> ""
  THEN DO:
    NEXT do_for_each.
  END.

  lDone = FALSE.

  FOR EACH tt-cust_depot WHERE
           tt-cust_depot.companycode = b-dp-own-prefix.companycode AND
           tt-cust_depot.cust_addressnr = b-dp-own-prefix.cust_addressnr
           NO-LOCK.
    FIND b2-dp-own-prefix WHERE
         b2-dp-own-prefix.companycode     = b-dp-own-prefix.companycode AND
         b2-dp-own-prefix.containerprefix = b-dp-own-prefix.containerprefix AND
         b2-dp-own-prefix.begin_range     = b-dp-own-prefix.begin_range AND
         b2-dp-own-prefix.end_range       = b-dp-own-prefix.end_range AND
         b2-dp-own-prefix.containertype   = b-dp-own-prefix.containertype AND
         b2-dp-own-prefix.depotcode       = tt-cust_depot.depotcode
         NO-LOCK NO-ERROR.
    IF NOT AVAIL b2-dp-own-prefix
    THEN DO:
      CREATE b2-dp-own-prefix.
      ASSIGN b2-dp-own-prefix.companycode     = b-dp-own-prefix.companycode
             b2-dp-own-prefix.containerprefix = b-dp-own-prefix.containerprefix
             b2-dp-own-prefix.begin_range     = b-dp-own-prefix.begin_range
             b2-dp-own-prefix.end_range       = b-dp-own-prefix.end_range
             b2-dp-own-prefix.containertype   = b-dp-own-prefix.containertype
             b2-dp-own-prefix.depotcode       = tt-cust_depot.depotcode
             .

    END.
  END.

  /* de originele met lege depotcode inactief zetten */
  ASSIGN b-dp-own-prefix.ind_inactive = TRUE.

  iDone = iDone + 1
  .
  RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).
END.



iTotal = iDone.

RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).



